# Installation

## Prerequisites

This part is only useful if you plan to install the package from source.

Else install the building tools

* gcc
* g++
* make
* cmake
* afb-cmake-modules

Then the following dependencies:

* json-c
* libsystemd
* afb-daemon
* libmicrohttpd
* afb-libhelpers
* gattlib 0.2.0
* glib2.0
* libbluetooth

Fedora/OpenSuse:

```bash
dnf install gcc-c++ make cmake afb-cmake-modules json-c-devel afb-binding-devel libmicrohttpd-devel afb-libhelpers-devel bluez-libs-devel glib2-devel
```

Ubuntu:

```bash
apt install gcc g++ make cmake afb-cmake-modules-bin libsystemd-dev libjson-c-dev afb-binding-dev libmicrohttpd-dev afb-libhelpers-dev libbluetooth-dev libglib2.0-dev
```

## Build

```bash
git clone https://github.com/redpesk-common/ble-sensor-binding.git
cd ble-sensor-binding
mkdir build
cd build
cmake ..
make 
```

## Link

* [ReadME](../README.md)
* [Architecture](1-Architecture.md)
* [Usage](3-Usage.md)
* [Protocole](4-Protocole.md)
