# BLE Sensor binding usage

## Root Usage

This service need to be run with root user due to the gattlib library. Indeed, this library need to communicate with bluetooth device (hci0) and need sudoers rules.

## Start afb-binder

Go to the source directory and run:

```bash
sudo afb-binder --name=afb-ble-sensor --port=1234 --workdir=./package --ldpaths=. -vvv
```

Your output will be like:

```bash
$ sudo afb-binder --name=afb-ble-sensor --port=1234 --workdir=./package --ldpaths=. -vvv
------BEGIN OF CONFIG-----
-- {
--    "name": "afb-ble-sensor",
--    "port": 1234,
--    "workdir": "./package",
--    "ldpaths": [
--      "."
--    ],
--    "apitimeout": 20,
--    "cache-eol": 100000,
--    "cntxtimeout": 32000000,
--    "session-max": 200,
--    "jobs-max": 200,
--    "threads-max": 5,
--    "uploaddir": ".",
--    "rootbase": "/opa",
--    "rootapi": "/api",
--    "rootdir": ".",
--    "log": "error+warning+notice+info+debug"
--  }
------END OF CONFIG-----
INFO: running with pid 150909
INFO: API monitor added
INFO: Can't connect supervision socket to @urn:AGL:afs:supervision:socket: Connection refused
NOTICE: Browser URL= http://localhost:1234
NOTICE: Serving rootdir=. uploaddir=.
INFO: Scanning dir=[./bin] for bindings
INFO: Scanning dir=[./etc] for bindings
INFO: Scanning dir=[./var] for bindings
INFO: Scanning dir=[./htdocs] for bindings
INFO: Scanning dir=[./htdocs/assets] for bindings
INFO: Scanning dir=[./lib] for bindings
INFO: binding [./lib/afb-ble-sensor.so] looks like an AFB binding V3
NOTICE: [API (null)] Controller in afbBindingEntry
NOTICE: [API (null)] Using default environnement config path : /home/val/workspace/src/redpesk_OS_Common_Components/ble-sensor-binding/conf.d/project/etc:/home/val/workspace/src/redpesk_OS_Common_Components/ble-sensor-binding/build/package/etc:/usr/local/ble-sensor-binding/etc
NOTICE: [API (null)] Json config directory : /home/val/workspace/src/redpesk_OS_Common_Components/ble-sensor-binding/conf.d/project/etc:/home/val/workspace/src/redpesk_OS_Common_Components/ble-sensor-binding/build/package/etc:/usr/local/ble-sensor-binding/etc:/home/val/workspace/src/redpesk_OS_Common_Components/ble-sensor-binding/build/package
DEBUG: [API (null)] CONFIG-SCANNING dir=/usr/local/ble-sensor-binding/etc not readable
WARNING: [API (null)] CTL-INIT JSON file found but not used : /home/val/workspace/src/redpesk_OS_Common_Components/ble-sensor-binding/build/package/etc/control-ble_ciss-bosh-config.json [/usr/src/packages/BUILD/ctl-lib/ctl-config.c:93,ConfigSearch]
WARNING: [API (null)] CTL-INIT JSON file found but not used : /home/val/workspace/src/redpesk_OS_Common_Components/ble-sensor-binding/build/package/etc/control-ble_ciss-bosh-config.json [/usr/src/packages/BUILD/ctl-lib/ctl-config.c:93,ConfigSearch]
NOTICE: [API (null)] api will be using config : /home/val/workspace/src/redpesk_OS_Common_Components/ble-sensor-binding/conf.d/project/etc/control-ble_ciss-bosh-config.json
INFO: [API (null)] CTL-LOAD-CONFIG: loading config filepath=/home/val/workspace/src/redpesk_OS_Common_Components/ble-sensor-binding/conf.d/project/etc/control-ble_ciss-bosh-config.json
NOTICE: [API (null)] Controller API='ble-sensor' info='Generic CISS Bosh sensor Config'
INFO: API ble-sensor added
DEBUG: [API ble-sensor] Plugin search path : '/home/val/workspace/src/redpesk_OS_Common_Components/ble-sensor-binding/build/package/package/lib/:/home/val/workspace/src/redpesk_OS_Common_Components/ble-sensor-binding/build/package/lib/../package/lib/:/home/val/workspace/src/redpesk_OS_Common_Components/ble-sensor-binding/build/package/./lib/plugins:/home/val/workspace/src/redpesk_OS_Common_Components/ble-sensor-binding/build/package/lib/.././lib/plugins:/home/val/workspace/src/redpesk_OS_Common_Components/ble-sensor-binding/build/package/./var:/home/val/workspace/src/redpesk_OS_Common_Components/ble-sensor-binding/build/package/lib/.././var'
DEBUG: [API (null)] CONFIG-SCANNING dir=/home/val/workspace/src/redpesk_OS_Common_Components/ble-sensor-binding/build/package/package/lib/ not readable
DEBUG: [API (null)] CONFIG-SCANNING dir=/home/val/workspace/src/redpesk_OS_Common_Components/ble-sensor-binding/build/package/lib/../package/lib/ not readable
NOTICE: [API ble-sensor] CTL-PLUGIN-LOADONE ciss-bosh successfully registered
WARNING: [API ble-sensor] Plugin multiple instances in searchpath will use /home/val/workspace/src/redpesk_OS_Common_Components/ble-sensor-binding/build/package/./lib/plugins/ciss-bosh.ctlso [/usr/src/packages/BUILD/ctl-lib/ctl-plugin.c:247,LoadFoundPlugins]
NOTICE: [API ble-sensor] Initialization of the CISS Boch sensor: POC at 46:03:55:1B:78:F4
INFO: Scanning dir=[./lib/plugins] for bindings
DEBUG: Init config done
NOTICE: API ble-sensor starting...
WARNING: [API ble-sensor] OnloadConfig Cannot Exec Non Existing Onload Action [/usr/src/packages/BUILD/ctl-lib/ctl-onload.c:38,OnloadConfig]
WARNING: [API ble-sensor] Warning 1 raised during call to 'onload' section callback [/usr/src/packages/BUILD/ctl-lib/ctl-config.c:171,CtlConfigExec]
INFO: API ble-sensor started
NOTICE: API monitor starting...
INFO: API monitor started
INFO: HTTP server starting
NOTICE: Listening interface *:1234
```

Now your application is reachable by HTTP or websocket through the port `1234`.  

## API usage

BLE Sensor binding creates one api/verb by sensor. By default each sensor api/verb is prefixed by the BLE group uid. With following config:

```json
{
  [...]
    "ble": [
        {
            "uid": "ciss",
            "info": "CISS Bosh sensors",
            "prefix": "ciss",
            "format": "plugin://ciss#saft",
            "sensors": [
                {
                    "uid": "POC",
                    "info": "Sensor used for POC",
                    "macAddr":"46:03:55:1B:78:F4",
                    "sample": [
                        {"action":"connect"},
                        {"action":"disconnect"},
                        {"action":"subscribe"},
                        {"action":"unsubscribe"}
                    ]
                }
            ] 
        }
    ]
  [...]
}
```

## BLE Sensor controller exposed

### Two builtin api/verb

* api://ble-sensor/ping -> check if binder is alive
* api://ble-sensor/info -> return registered Sensors

### Two Actions for BLE group

* api://ble-sensor/${BLE_uid}/admin {"action": "connect"} -> To connect all sensors into this BLE group
* api://ble-sensor/${BLE_uid}/admin {"action": "disconnect"} -> To disconnect all sensors into this BLE group

### Four Actions for Sensor

* api://ble-sensor/${BLE_uid}/${Sensor_uid} {"action": "connect"} -> To connect the sensor
* api://ble-sensor/${BLE_uid}/${Sensor_uid} {"action": "disconnect"} -> To disconnect the sensor
* api://ble-sensor/${BLE_uid}/${Sensor_uid} {"action": "subscribe"} -> Subscribe to event push by the sensor (/!\ Need to be connected)
* api://ble-sensor/${BLE_uid}/${Sensor_uid} {"action": "unsubscribe"} -> Unsubscribe from event push by the sensor
* api://ble-sensor/${BLE_uid}/${Sensor_uid} {"action": "config", "data":"{...}"} -> Send config to the sensor (/!\ Need to be connected)

#### Config

* Example:

```bash
ble-sensor ciss/POC {"action":"config", "data": "{"samplingRate":2,"dataSelection":1,"blePowerLevel":5}"}
```

## Start binding

Open a new terminal and do the following requests:

```bash
afb-client -H ws://localhost:1234/api
```

## Use it

```bash
ble-sensor info
{
  "jtype":"afb-reply",
  "request":{
    "status":"success"
  },
  "response":{
    "metadata":{
      "uid":"ble-sensor",
      "info":"Generic CISS Bosh sensor Config",
      "version":"1.0"
    },
    "groups":[
      {
        "uid":"ciss",
        "info":"CISS Bosh sensors",
        "verbs":[
          {
            "uid":"POC",
            "family":"ciss",
            "info":"Sensor used for POC",
            "macAddr":"46:03:55:1B:78:F4",
            "sample":[
              {
                "action":"write",
                "data":"test"
              },
              {
                "action":"read"
              },
              {
                "action":"subscribe"
              },
              {
                "action":"unsubscribe"
              }
            ]
          }
        ]
      }
    ]
  }
}
```

## Link

- [ReadMe](../README.md)
- [Architecture](1-Architecture.md)
- [Installation](2-Installation.md)
- [Protocole](4-Protocole.md)